#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <conio.h>
#include <windows.h>
#include <mmsystem.h>
#include "calc_e_core.h"
#include "progress.h"

enum {
	FORMAT_TEXT,
	FORMAT_TEXT2,
	FORMAT_RAW,
	FORMAT_BINARY
};

const int div10[9]={
	100000000,
	10000000,
	1000000,
	100000,
	10000,
	1000,
	100,
	10,
	1
};

int main(int argc,char* argv[]) {
	/* ݒp[^ */ 
	unsigned int maxDigit=0;
	int format=FORMAT_TEXT;
	const char* saveFile=NULL;
	const char* outputFile=NULL;
	int outpute=1; /* ŏ"2."o͂邩ǂ */
	/* vZpϐ */
	unsigned long long usedTime=0;
	unsigned int prevTime,nowTime;
	int calcMemory=0;
	unsigned int* e=NULL;
	unsigned int* now=NULL;
	unsigned int nowNumber=0;
	int firstNonZero=0;
	/* o͗pϐ */
	FILE* fpOut=NULL;
	unsigned char binBuffer;
	/* ̑ */
	int i;
	int parseError=0;
	for(i=1;i<argc;i++) {
		if(strcmp(argv[i],"-d")==0) { /*  */
			if(i+1<argc) {
				if(sscanf(argv[i+1],"%u",&maxDigit)!=1)parseError=1;
				i++;
			} else parseError=1;
		} else if(strcmp(argv[i],"-r")==0) { /* fpt@C */
			if(i+1<argc) {
				saveFile=argv[i+1];
				i++;
			} else parseError=1;
		} else if(strcmp(argv[i],"-o")==0) { /* o̓t@C */ 
			if(i+1<argc) {
				outputFile=argv[i+1];
				i++;
			} else parseError=1;
		} else if(strcmp(argv[i],"-f")==0) { /* o̓tH[}bg */
			if(i+1<argc) {
				i++;
				if(strcmp(argv[i],"text")==0) {
					format=FORMAT_TEXT;
				} else if(strcmp(argv[i],"text2")==0) {
					format=FORMAT_TEXT2;
				} else if(strcmp(argv[i],"raw")==0) {
					format=FORMAT_RAW;
				} else if(strcmp(argv[i],"binary")==0) {
					format=FORMAT_BINARY;
				} else parseError=1;
			} else parseError=1;
		} else if(strcmp(argv[i],"-e")==0) { /* ŏ"2."o͂邩ǂ */
			if(i+1<argc) {
				i++;
				if(strcmp(argv[i],"yes")==0) {
					outpute=1;
				} else if(strcmp(argv[i],"no")==0) {
					outpute=0;
				} else parseError=1;
			} else parseError=1;
		} else {
			parseError=1;
		}
	}
	if(parseError || (maxDigit==0 && saveFile==NULL)) {
		fputs("Usage: calc_long_e [options]\n",stderr);
		fputs("IvVꗗ\n",stderr);
		fputs("-d  : vZ錅w\n",stderr);
		fputs("-r t@C : fZ[up̃t@Cw\n",stderr);
		fputs("-o t@C : ʂo͂t@Cw(ȗƕWo)\n",stderr);
		fputs("  ݂t@Cw肷ƓǂݍōĊJ\n",stderr);
		fputs("-f <text|text2|raw|binary> : o̓tH[}bgw\n",stderr);
		fputs("-e <yes|no> : ŏ\"2.\"o͂邩w\n",stderr);
		return 1; 
	}

	/* ft@C̓ǂݍ */ 
	if(saveFile!=NULL && maxDigit==0) {
		FILE* fp;
		fp=fopen(saveFile,"rb");
		if(fp!=NULL) {
			int error=0;
			if(fread(&maxDigit,sizeof(maxDigit),1,fp)!=1)error=1;
			if(fread(&format,sizeof(format),1,fp)!=1)error=1;
			if(fread(&outpute,sizeof(outpute),1,fp)!=1)error=1;
			if(fread(&usedTime,sizeof(usedTime),1,fp)!=1)error=1;
			if(fread(&nowNumber,sizeof(nowNumber),1,fp)!=1)error=1;
			if(format<FORMAT_TEXT || format>FORMAT_BINARY)error=1;
			if(maxDigit==0)error=1;
			if(error) {
				fputs("ft@CĂ܂B\n",stderr); 
			} else {
				calcMemory=getNeededMemory(maxDigit);
				e=malloc(sizeof(unsigned int)*calcMemory);
				now=malloc(sizeof(unsigned int)*calcMemory);
				if(e==NULL || now==NULL) {
					error=1;
					if(e)free(e);
					if(now)free(now);
					fputs("̊mۂɎs܂B\n",stderr); 
				} else {
					if(fread(e,sizeof(unsigned int),calcMemory,fp)!=calcMemory)error=1;
					if(fread(now,sizeof(unsigned int),calcMemory,fp)!=calcMemory)error=1;
					if(error)fputs("ft@CĂ܂B\n",stderr);
				}
			}
			fclose(fp);
			if(error)return 1;
		}
	}
	/*  */
	firstNonZero=0;
	if(e==NULL) {
		calcMemory=getNeededMemory(maxDigit);
		e=malloc(sizeof(unsigned int)*calcMemory);
		now=malloc(sizeof(unsigned int)*calcMemory);
		if(e==NULL || now==NULL) {
			if(e)free(e);
			if(now)free(now);
			fputs("̊mۂɎs܂B\n",stderr);
			return 1;
		}
		for(i=0;i<calcMemory;i++)e[i]=now[i]=0;
		now[0]=500000000;
		nowNumber=2;
	}

	/* vZ */
	fputs("vZ...\n",stderr);
	initProgress(calcMemory);
	prevTime=timeGetTime();
	while(firstNonZero<calcMemory) {
		addLongInt(e,now,calcMemory,firstNonZero);
		nowNumber++;
		firstNonZero=divLongInt(now,nowNumber,calcMemory,firstNonZero);
		updateProgress(firstNonZero);
		if(nowNumber%100==0) {
			nowTime=timeGetTime();
			usedTime+=nowTime-prevTime;
			prevTime=nowTime;
		}
		/* fZ[u */
		if(kbhit() && getch()=='q' && saveFile!=NULL) {
			FILE* fp;
			nowTime=timeGetTime();
			usedTime+=nowTime-prevTime;
			prevTime=nowTime;

			fputc('\n',stderr);
			fp=fopen(saveFile,"wb");
			if(fp!=NULL) {
				int error=0;
				if(fwrite(&maxDigit,sizeof(maxDigit),1,fp)!=1)error=1;
				if(fwrite(&format,sizeof(format),1,fp)!=1)error=1;
				if(fwrite(&outpute,sizeof(outpute),1,fp)!=1)error=1;
				if(fwrite(&usedTime,sizeof(usedTime),1,fp)!=1)error=1;
				if(fwrite(&nowNumber,sizeof(nowNumber),1,fp)!=1)error=1;
				if(fwrite(e,sizeof(unsigned int),calcMemory,fp)!=calcMemory)error=1;
				if(fwrite(now,sizeof(unsigned int),calcMemory,fp)!=calcMemory)error=1;

				fclose(fp);
				if(error) {
					fputs("t@Cւ݂̏Ɏs܂B\n",stderr);
					fputs("Ԃ͏ł܂B߂ȂB\n",stderr);
				} else {
					fputs("݂̏Ԃo܂B\n",stderr);
				}
			} else {
				fputs("t@CI[vɎs܂B\n",stderr);
				fputs("Ԃ͏ł܂B߂ȂB\n",stderr);
			}
			free(e);
			free(now);
			return 0;
		}
	}
	usedTime+=timeGetTime()-prevTime;
	fputc('\n',stderr);

	/* vZ̏\ */
	fputs("vZI\n",stderr);
	fprintf(stderr,"vZK̍ő : %u\n",nowNumber);
	fputs("v : ",stderr);
	if(usedTime>=24*60*60*1000)fprintf(stderr,"%d",(int)(usedTime/(24*60*60*1000)));
	if(usedTime>=60*60*1000)fprintf(stderr,"%d",(int)((usedTime/(60*60*1000))%24));
	if(usedTime>=60*1000)fprintf(stderr,"%d",(int)((usedTime/(60*1000))%60));
	fprintf(stderr,"%db%03d\n",(int)((usedTime/1000)%60),(int)(usedTime%1000)); 

	/* o */
	fputs("vZʂo͒...\n",stderr);
	initProgress(maxDigit);
	if(outputFile)fpOut=fopen(outputFile,format==FORMAT_BINARY?"wb":"w");
	if(fpOut==NULL)fpOut=stdout;
	if(outpute && format!=FORMAT_BINARY)fputs("2.",fpOut);
	for(i=0;i<maxDigit;i++) {
		int nowDigit=(e[i/9]/div10[i%9])%10;
		if(format==FORMAT_BINARY) {
			binBuffer=(binBuffer<<4)|nowDigit;
			if(i%2==1)fwrite(&binBuffer,sizeof(binBuffer),1,fpOut);
		} else {
			fprintf(fpOut,"%d",nowDigit);
			if(format!=FORMAT_RAW) {
				if(i%10==9) {
					if(i%100==99) {
						if(format==FORMAT_TEXT2 && (i+1)%1000==0) {
							fprintf(fpOut," -%d",i+1);
						}
						fputc('\n',fpOut);
						if(format==FORMAT_TEXT2 && (i+1)%10000==0) {
							fputc('\n',fpOut);
						}
						if(outpute)fputs("  ",fpOut);
					} else fputc(' ',fpOut);
				}
			}
		}
		updateProgress(i);
	}
	updateProgress(i);
	putchar('\n');
	if(fpOut!=stdout)fclose(fpOut);

	free(e);
	free(now);
	return 0;
}
